#define __ICTRLLER_H


#ifndef __SAINT_H
#include "saint.h"
#endif
#ifndef __OPRDR_H
#include "oprdr.h"
#endif
#ifndef __CTL3DLDR_H
#include "ctl3dldr.h"
#endif
#ifndef __INSTALLR_H
#include "installr.h"
#endif


class iinfo;

class dcontext;


/* we must call init() to initilize it */
class ictrller
{
   friend LRESULT CALLBACK bkwndproc(HWND wnd, UINT msg, WPARAM wp, LPARAM lp);

   int createshowbkwnd();
   void loadctl3d();
   void freectl3d();
   void paint();
   void drawbktxts(HDC dc);
   void drawgradient(HDC dc, RECT &r);
   void drawunregifneed(HDC dc);
   void createbkwndclass();
   HWND createbkwnd(int x, int y, int w, int h);
   HFONT createbktxtf(dcontext &dc, int i);

   public:

  ~ictrller();

   int scrw;                                     /* width of screen (in pixel) */
   int scrh;                                    /* height of screen (in pixel) */
   int oldemode;                                        /* original error mode */
   char diri[260];                                 /* install target directory */
   HWND bkwnd;                                            /* background window */
   saint ics;                                    /* is the component selected? */
   saint ifs;                                         /* is the file selected? */
   saint iis;                                         /* is the item selected? */
   saint ies;                                        /* is the entry selected? */
   saint irs;                                      /* is the reg key selected? */
   filog log;                                                      /* log file */
   iinfo *ii;                                       /* custom install info obj */
   double pnt2pxlx;       /* horz factor to convert point (1/72 inch) to pixel */
   double pnt2pxly;       /* vert factor to convert point (1/72 inch) to pixel */
   double spaceneeded;                               /* hard disk space needed */
   installer ir;                                                  /* installer */
   ctl3dloader cl;                        /* used to load and free ctl3dv2.dll */

   virtual int run()       = 0;      /* derived class defines the control flow */
   virtual void createii() = 0;            /* derived class should set ii here */

   char *getdiri()
   {
      return diri;
   }
   char *getdirs()
   {
      return ir.getdirs();
   }
   char *getdirw()
   {
      return ir.getdirw();
   }
   char *getdiry()
   {
      return ir.getdiry();
   }

   int init(char dirs[]);
   int askdir();
   int welcome();
   int execprgm(DWORD *r);
   int copyfiles();
   int setregkeys();
   int createitems();
   int selectcomps();
   int setinientries();
   void done();
};
